Index: conf/files.i386
===========================================================================
--- sys/conf/files.i386	2003/10/30 14:48:07	#88
+++ conf/files.i386	2003/10/30 14:48:07
@@ -167,12 +167,14 @@
 	no-obj no-implicit-rule before-depend				\
 	clean		"acpi_wakecode.h acpi_wakecode.o acpi_wakecode.bin"
 #
+i386/acpica/madt.c		optional	acpi apic
 i386/bios/apm.c			optional	apm
 i386/bios/mca_machdep.c		optional	mca
 i386/bios/smapi.c		optional	smapi
 i386/bios/smapi_bios.S		optional	smapi
 i386/bios/smbios.c		optional	smbios
 i386/bios/vpd.c			optional	vpd
+i386/i386/apic_vector.s		optional	apic
 i386/i386/atomic.c		standard				\
 	compile-with	"${CC} -c ${CFLAGS} ${DEFINED_PROF:S/^$/-fomit-frame-pointer/} ${.IMPSRC}"
 i386/i386/autoconf.c		standard
@@ -193,15 +195,20 @@
 i386/i386/identcpu.c		standard
 i386/i386/in_cksum.c		optional	inet
 i386/i386/initcpu.c		standard
+i386/i386/intr_machdep.c	standard
+i386/i386/io_apic.c		optional	apic
 i386/i386/k6_mem.c		standard
 i386/i386/legacy.c		standard
+i386/i386/local_apic.c		optional	apic
 i386/i386/locore.s		standard	no-obj
 i386/i386/machdep.c		standard
 i386/i386/mem.c			standard
 i386/i386/mp_clock.c		optional	smp
 i386/i386/mp_machdep.c		optional	smp
-i386/i386/mpapic.c		optional	smp
 i386/i386/mpboot.s		optional	smp
+i386/i386/mptable.c		optional	smp
+i386/i386/mptable.c		optional	apic
+i386/i386/mptable_pci.c		optional	apic pci
 i386/i386/nexus.c		standard
 i386/i386/perfmon.c		optional	perfmon
 i386/i386/perfmon.c		optional	perfmon	profiling-routine
@@ -233,6 +240,8 @@
 i386/ibcs2/ibcs2_xenix_sysent.c	optional	ibcs2
 i386/ibcs2/imgact_coff.c	optional	ibcs2
 i386/isa/asc.c			count		asc
+i386/isa/atpic.c		standard
+i386/isa/atpic_vector.s		standard
 i386/isa/clock.c		standard
 i386/isa/cronyx.c		optional	cx
 i386/isa/ctx.c			optional	ctx
@@ -246,8 +255,6 @@
 i386/isa/if_el.c		count		el
 i386/isa/if_le.c		count		le
 i386/isa/if_rdp.c		count		rdp
-i386/isa/intr_machdep.c		standard
-i386/isa/ithread.c		standard
 i386/isa/isa.c			optional	isa
 i386/isa/isa_compat.c		optional	isa compat_oldisa	\
 	warning "Old ISA driver compatibility shims present."
@@ -255,6 +262,7 @@
 i386/isa/istallion.c		optional	stli nowerror
 i386/isa/loran.c		optional	loran
 i386/isa/mse.c			optional	mse
+i386/isa/nmi.c			standard
 i386/isa/npx.c			optional	npx
 i386/isa/pcf.c			optional	pcf
 i386/isa/pcvt/pcvt_drv.c	optional	vt
Index: conf/options.i386
===========================================================================
--- sys/conf/options.i386	2003/10/30 14:48:07	#49
+++ conf/options.i386	2003/10/30 14:48:07
@@ -7,6 +7,7 @@
 COMPAT_OLDISA
 I586_PMC_GUPROF		opt_i586_guprof.h
 MAXMEM
+NO_MIXED_MODE
 PERFMON
 DISABLE_PSE		opt_pmap.h
 DISABLE_PG_G		opt_pmap.h
@@ -25,8 +26,6 @@
 DEBUG_SVR4		opt_svr4.h
 PECOFF_SUPPORT		opt_dontuse.h
 PECOFF_DEBUG		opt_pecoff.h
-# i386 SMP options
-APIC_IO			opt_global.h
 
 # Change KVM size.  Changes things all over the kernel.
 KVA_PAGES		opt_global.h
@@ -146,6 +145,7 @@
 IPR_LOG			opt_i4b.h
 
 # Device options
+DEV_APIC		opt_apic.h
 DEV_NPX			opt_npx.h
 
 # -------------------------------
Index: contrib/dev/acpica/tbxfroot.c
===========================================================================
--- sys/contrib/dev/acpica/tbxfroot.c	2003/10/30 14:48:07	#12
+++ contrib/dev/acpica/tbxfroot.c	2003/10/30 14:48:07
@@ -420,6 +420,8 @@
         return_ACPI_STATUS (AE_NO_ACPI_TABLES);
     }
 
+    /* XXXTEST */
+    printf("%s: found RSDP at 0x%jx\n", __func__, TableInfo.PhysicalAddress);
     RsdpAddress->PointerType = ACPI_PHYSICAL_POINTER;
     RsdpAddress->Pointer.Physical = TableInfo.PhysicalAddress;
     return_ACPI_STATUS (AE_OK);
@@ -522,6 +524,7 @@
          */
         Status = AcpiOsMapMemory ((UINT64) ACPI_LO_RSDP_WINDOW_BASE, ACPI_LO_RSDP_WINDOW_SIZE,
                                     (void **) &TablePtr);
+	printf("%s: Map(%jx, %u) = %p\n", __func__, (uintmax_t)ACPI_LO_RSDP_WINDOW_BASE, ACPI_LO_RSDP_WINDOW_SIZE, TablePtr);
         if (ACPI_FAILURE (Status))
         {
             ACPI_DEBUG_PRINT ((ACPI_DB_ERROR, "Could not map memory at %X for length %X\n",
@@ -538,6 +541,7 @@
 
             PhysAddr = ACPI_LO_RSDP_WINDOW_BASE;
             PhysAddr += ACPI_PTR_DIFF (MemRover,TablePtr);
+	    printf("%s: Found at %p, PA = %jx\n", __func__, MemRover, (uintmax_t)PhysAddr);
 
             TableInfo->PhysicalAddress = PhysAddr;
             return_ACPI_STATUS (AE_OK);
@@ -548,6 +552,7 @@
          */
         Status = AcpiOsMapMemory ((UINT64) ACPI_HI_RSDP_WINDOW_BASE, ACPI_HI_RSDP_WINDOW_SIZE,
                                     (void **) &TablePtr);
+	printf("%s: Map(%jx, %u) = %p\n", __func__, (uintmax_t)ACPI_HI_RSDP_WINDOW_BASE, ACPI_HI_RSDP_WINDOW_SIZE, TablePtr);
         if (ACPI_FAILURE (Status))
         {
             ACPI_DEBUG_PRINT ((ACPI_DB_ERROR, "Could not map memory at %X for length %X\n",
@@ -565,6 +570,7 @@
             PhysAddr = ACPI_HI_RSDP_WINDOW_BASE;
             PhysAddr += ACPI_PTR_DIFF (MemRover, TablePtr);
 
+	    printf("%s: Found at %p, PA = %jx\n", __func__, MemRover, (uintmax_t)PhysAddr);
             TableInfo->PhysicalAddress = PhysAddr;
             return_ACPI_STATUS (AE_OK);
         }
Index: dev/pci/pci.c
===========================================================================
--- sys/dev/pci/pci.c	2003/10/30 14:48:07	#56
+++ dev/pci/pci.c	2003/10/30 14:48:07
@@ -820,7 +820,7 @@
 	}
 
 	if (cfg->intpin > 0 && PCI_INTERRUPT_VALID(cfg->intline)) {
-#if defined(__ia64__) || (defined(__i386__) && !defined(SMP))
+#if defined(__ia64__) || defined(__i386__)
 		/*
 		 * Try to re-route interrupts. Sometimes the BIOS or
 		 * firmware may leave bogus values in these registers.
Index: dev/sio/sio.c
===========================================================================
--- sys/dev/sio/sio.c	2003/10/30 14:48:07	#67
+++ dev/sio/sio.c	2003/10/30 14:48:07
@@ -1161,6 +1161,9 @@
 	rid = 0;
 	com->irqres = bus_alloc_resource(dev, SYS_RES_IRQ, &rid, 0ul, ~0ul, 1,
 	    RF_ACTIVE);
+	if (com->irqres == NULL)
+		com->irqres = bus_alloc_resource(dev, SYS_RES_IRQ, &rid, 0ul,
+		    ~0ul, 1, RF_ACTIVE | RF_SHAREABLE);
 	if (com->irqres) {
 		ret = BUS_SETUP_INTR(device_get_parent(dev), dev, com->irqres,
 				     INTR_TYPE_TTY | INTR_FAST,
Index: i386/acpica/acpi_wakeup.c
===========================================================================
--- sys/i386/acpica/acpi_wakeup.c	2003/10/30 14:48:07	#28
+++ i386/acpica/acpi_wakeup.c	2003/10/30 14:48:07
@@ -47,10 +47,9 @@
 
 #include <machine/bus.h>
 #include <machine/cpufunc.h>
+#include <machine/intr_machdep.h>
 #include <machine/segments.h>
 
-#include <i386/isa/intr_machdep.h>
-
 #include "acpi.h"
 #include <dev/acpica/acpivar.h>
 
@@ -222,6 +221,8 @@
 	ret_addr = 0;
 	if (acpi_savecpu()) {
 		/* Execute Sleep */
+		intr_suspend();
+
 		p_gdt = (struct region_descriptor *)
 				(sc->acpi_wakeaddr + physical_gdt);
 		p_gdt->rd_limit = r_gdt.rd_limit;
@@ -271,7 +272,7 @@
 #if 0
 		initializecpu();
 #endif
-		icu_reinit();
+		intr_resume();
 
 		if (acpi_get_verbose(sc)) {
 			acpi_savecpu();
Index: i386/acpica/madt.c
===========================================================================
*** /dev/null	Thu Oct 30 14:47:44 2003
--- i386/acpica/madt.c	Thu Oct 30 14:48:08 2003
***************
*** 0 ****
--- 1,641 ----
+ /*-
+  * Copyright (c) 2003 John Baldwin <jhb@FreeBSD.org>
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $FreeBSD$
+  */
+ 
+ #include <sys/param.h>
+ #include <sys/systm.h>
+ #include <sys/bus.h>
+ #include <sys/kernel.h>
+ #include <sys/malloc.h>
+ 
+ #include <vm/vm.h>
+ #include <vm/vm_param.h>
+ #include <vm/pmap.h>
+ 
+ #include <machine/apicreg.h>
+ #include <machine/frame.h>
+ #include <machine/intr_machdep.h>
+ #include <machine/apicvar.h>
+ #include <machine/md_var.h>
+ #include <machine/specialreg.h>
+ 
+ #include "acpi.h"
+ #include <dev/acpica/acpivar.h>
+ #include <dev/acpica/madt.h>
+ #include <dev/pci/pcivar.h>
+ 
+ #define	NIOAPICS		16	/* Max number of I/O APICs */
+ #define	NLAPICS			16	/* Max number of local APICs */
+ 
+ typedef	void madt_entry_handler(APIC_HEADER *entry, void *arg);
+ 
+ /* These two arrays are indexed by APIC IDs. */
+ struct ioapic_info {
+ 	void *io_apic;
+ 	UINT32 io_vector;
+ } ioapics[NIOAPICS];
+ 
+ struct lapic_info {
+ 	int la_present:1;
+ 	int la_enabled:1;
+ 	int la_apic_id:8;
+ } lapics[NLAPICS + 1];
+ 
+ static APIC_TABLE *madt;
+ static vm_paddr_t madt_physaddr;
+ static vm_offset_t madt_length;
+ 
+ MALLOC_DEFINE(M_MADT, "MADT Table", "ACPI MADT Table Items");
+ 
+ static u_char	interrupt_polarity(UINT16 Polarity);
+ static u_char	interrupt_trigger(UINT16 TriggerMode);
+ static int	madt_find_cpu(u_int acpi_id, u_int *apic_id);
+ static int	madt_find_interrupt(int intr, void **apic, u_int *pin);
+ static void	*madt_map(vm_paddr_t pa, int offset, vm_offset_t length);
+ static void	*madt_map_table(vm_paddr_t pa, int offset, const char *sig);
+ static void	madt_parse_apics(APIC_HEADER *entry, void *arg);
+ static void	madt_parse_interrupt_override(INTERRUPT_SOURCE_OVERRIDE *intr);
+ static void	madt_parse_ints(APIC_HEADER *entry, void *arg __unused);
+ static void	madt_parse_local_nmi(LAPIC_NMI *nmi);
+ static void	madt_parse_nmi(NMI *nmi);
+ static int	madt_probe(void);
+ static int	madt_probe_cpus(void);
+ static void	madt_probe_cpus_handler(APIC_HEADER *entry, void *arg __unused);
+ static int	madt_probe_table(vm_paddr_t address);
+ static void	madt_register(void *dummy);
+ static int	madt_setup_local(void);
+ static int	madt_setup_io(void);
+ static void	madt_unmap(void *data, vm_offset_t length);
+ static void	madt_unmap_table(void *table);
+ static void	madt_walk_table(madt_entry_handler *handler, void *arg);
+ 
+ static struct apic_enumerator madt_enumerator = {
+ 	"MADT",
+ 	madt_probe,
+ 	madt_probe_cpus,
+ 	madt_setup_local,
+ 	madt_setup_io
+ };
+ 
+ /*
+  * Code to abuse the crashdump map to map in the tables for the early
+  * probe.  We cheat and make the following assumptions about how we
+  * use this KVA: page 0 is used to map in the first page of each table
+  * found via the RSDT or XSDT and pages 1 to n are used to map in the
+  * RSDT or XSDT.  The offset is in pages; the length is in bytes.
+  */
+ static void *
+ madt_map(vm_paddr_t pa, int offset, vm_offset_t length)
+ {
+ 	vm_offset_t va, off;
+ 	void *data;
+ 
+ 	off = pa & PAGE_MASK;
+ 	length = roundup(length + off, PAGE_SIZE);
+ 	pa = pa & PG_FRAME;
+ 	va = (vm_offset_t)pmap_kenter_temporary(pa, offset) +
+ 	    (offset * PAGE_SIZE);
+ 	data = (void *)(va + off);
+ 	length -= PAGE_SIZE;
+ 	while (length > 0) {
+ 		va += PAGE_SIZE;
+ 		pa += PAGE_SIZE;
+ 		length -= PAGE_SIZE;
+ 		pmap_kenter(va, pa);
+ 		invlpg(va);
+ 	}
+ 	return (data);
+ }
+ 
+ static void
+ madt_unmap(void *data, vm_offset_t length)
+ {
+ 	vm_offset_t va, off;
+ 
+ 	va = (vm_offset_t)data;
+ 	off = va & PAGE_MASK;
+ 	length = roundup(length + off, PAGE_SIZE);
+ 	va &= ~PAGE_MASK;
+ 	while (length > 0) {
+ 		pmap_kremove(va);
+ 		invlpg(va);
+ 		va += PAGE_SIZE;
+ 		length -= PAGE_SIZE;
+ 	}
+ }
+ 
+ static void *
+ madt_map_table(vm_paddr_t pa, int offset, const char *sig)
+ {
+ 	ACPI_TABLE_HEADER *header;
+ 	vm_offset_t length;
+ 
+ 	header = madt_map(pa, offset, sizeof(ACPI_TABLE_HEADER));
+ 	if (strncmp(header->Signature, sig, 4) != 0) {
+ 		madt_unmap(header, sizeof(ACPI_TABLE_HEADER));
+ 		return (NULL);
+ 	}
+ 	length = header->Length;
+ 	madt_unmap(header, sizeof(ACPI_TABLE_HEADER));
+ 	return (madt_map(pa, offset, length));
+ }
+ 
+ static void
+ madt_unmap_table(void *table)
+ {
+ 	ACPI_TABLE_HEADER *header;
+ 
+ 	header = (ACPI_TABLE_HEADER *)table;
+ 	madt_unmap(table, header->Length);
+ }
+ 
+ /*
+  * Look for an ACPI Multiple APIC Description Table ("APIC")
+  */
+ static int
+ madt_probe(void)
+ {
+ 	ACPI_POINTER rsdp_ptr;
+ 	RSDP_DESCRIPTOR *rsdp;
+ 	RSDT_DESCRIPTOR *rsdt;
+ 	XSDT_DESCRIPTOR *xsdt;
+ 	int i, count;
+ 
+ 	if (resource_disabled("acpi", 0))
+ 		return (ENXIO);
+ 
+ 	/*
+ 	 * Map in the RSDP.  Since ACPI uses AcpiOsMapMemory() which in turn
+ 	 * calls pmap_mapdev() to find the RSDP, we assume that we can use
+ 	 * pmap_mapdev() to map the RSDP.
+ 	 */
+ 	if (AcpiOsGetRootPointer(ACPI_LOGICAL_ADDRESSING, &rsdp_ptr) != AE_OK)
+ 		return (ENXIO);
+ 	/* XXXTEST */
+ 	printf("rsdp_ptr.Pointer.Logical = %p\n",
+ 	    (void *)rsdp_ptr.Pointer.Logical);
+ 	printf("rsdp_ptr.Pointer.Physical = 0x%jx\n",
+ 	    (uintmax_t)rsdp_ptr.Pointer.Physical);
+ 	KASSERT(rsdp_ptr.Pointer.Physical < KERNLOAD, ("RSDP too high"));
+ 	rsdp = pmap_mapdev(rsdp_ptr.Pointer.Physical, sizeof(RSDP_DESCRIPTOR));
+ 	if (rsdp == NULL) {
+ #if 0
+ 		if (bootverbose)
+ #endif
+ 			printf("MADT: Failed to map RSDP\n");
+ 		return (ENXIO);
+ 	}
+ 
+ 	/*
+ 	 * For ACPI < 2.0, use the RSDT.  For ACPI >= 2.0, use the XSDT.
+ 	 * We map the XSDT and RSDT at page 1 in the crashdump area.
+ 	 * Page 0 is used to map in the headers of candidate ACPI tables.
+ 	 */
+ 	if (rsdp->Revision >= 2) {
+ 		/* XXXTEST */
+ 		printf("XSDT PA = 0x%jx\n", (uintmax_t)rsdp->XsdtPhysicalAddress);
+ 		xsdt = madt_map_table(rsdp->XsdtPhysicalAddress, 1, XSDT_SIG);
+ 		if (xsdt == NULL) {
+ #if 0
+ 			if (bootverbose)
+ #endif
+ 				printf("MADT: Failed to map XSDT\n");
+ 			return (ENXIO);
+ 		}
+ 		count = (xsdt->Header.Length - sizeof(ACPI_TABLE_HEADER)) /
+ 		    sizeof(UINT64);
+ 		for (i = 0; i < count; i++)
+ 			if (madt_probe_table(xsdt->TableOffsetEntry[i]))
+ 				break;
+ 		madt_unmap_table(xsdt);
+ 	} else {
+ 		/* XXXTEST */
+ 		printf("RSDT PA = 0x%jx\n", (uintmax_t)rsdp->RsdtPhysicalAddress);
+ 		rsdt = madt_map_table(rsdp->RsdtPhysicalAddress, 1, RSDT_SIG);
+ 		if (rsdt == NULL) {
+ #if 0
+ 			if (bootverbose)
+ #endif
+ 				printf("MADT: Failed to map RSDT\n");
+ 			return (ENXIO);
+ 		}
+ 		count = (rsdt->Header.Length - sizeof(ACPI_TABLE_HEADER)) /
+ 		    sizeof(UINT32);
+ 		for (i = 0; i < count; i++)
+ 			if (madt_probe_table(rsdt->TableOffsetEntry[i]))
+ 				break;
+ 		madt_unmap_table(rsdt);
+ 	}
+ 	pmap_unmapdev((vm_offset_t)rsdp, sizeof(RSDP_DESCRIPTOR));
+ 	if (madt_physaddr == 0) {
+ #if 0
+ 		if (bootverbose)
+ #endif
+ 			printf("MADT: No MADT table found\n");
+ 		return (ENXIO);
+ 	}
+ #if 0
+ 	if (bootverbose)
+ #endif
+ 		printf("MADT: Found table at %p\n", (void *)madt_physaddr);
+ 
+ 	return (0);
+ }
+ 
+ /*
+  * See if a given ACPI table is the MADT.
+  */
+ static int
+ madt_probe_table(vm_paddr_t address)
+ {
+ 	ACPI_TABLE_HEADER *table;
+ 
+ 	table = madt_map(address, 0, sizeof(ACPI_TABLE_HEADER));
+ 	if (table == NULL) {
+ #if 0
+ 		if (bootverbose)
+ #endif
+ 			printf("MADT: Failed to map table at %p\n",
+ 			    (void *)address);
+ 		return (0);
+ 	}
+ #if 0
+ 	if (bootverbose)
+ #endif
+ 		printf("Table '%.4s' at %p\n", table->Signature,
+ 		    (void *)address);
+ 
+ 	/* XXX: Verify checksum? */
+ 	if (strncmp(table->Signature, APIC_SIG, 4) != 0) {
+ 		madt_unmap(table, sizeof(ACPI_TABLE_HEADER));
+ 		return (0);
+ 	}
+ 	madt_physaddr = address;
+ 	madt_length = table->Length;
+ 	madt_unmap(table, sizeof(ACPI_TABLE_HEADER));
+ 	return (1);
+ }
+ 
+ /*
+  * Run through the MP table enumerating CPUs.
+  */
+ static int
+ madt_probe_cpus(void)
+ {
+ 
+ 	madt = madt_map_table(madt_physaddr, 0, APIC_SIG);
+ 	KASSERT(madt != NULL, ("Unable to re-map MADT"));
+ 	madt_walk_table(madt_probe_cpus_handler, NULL);
+ 	madt_unmap_table(madt);
+ 	madt = NULL;
+ 	return (0);
+ }
+ 
+ /*
+  * Initialize the local APIC on the BSP.
+  */
+ static int
+ madt_setup_local(void)
+ {
+ 
+ 	madt = pmap_mapdev(madt_physaddr, madt_length);
+ 	lapic_init((uintptr_t)madt->LocalApicAddress);
+ 	printf("ACPI APIC Table: <%.*s %.*s>\n",
+ 	    sizeof(madt->Header.OemId), madt->Header.OemId,
+ 	    sizeof(madt->Header.OemTableId), madt->Header.OemTableId);
+ 
+ 	/*
+ 	 * We ignore 64-bit local APIC override entries.  Should we
+ 	 * perhaps emit a warning here if we find one?
+ 	 */
+ 	return (0);
+ }
+ 
+ /*
+  * Run through the MP table enumerating I/O APICs.
+  */
+ static int
+ madt_setup_io(void)
+ {
+ 	int i;
+ 
+ 	/* First, we run through adding I/O APIC's. */
+ 	madt_walk_table(madt_parse_apics, NULL);
+ 
+ 	/* Second, we run through the table tweaking interrupt sources. */
+ 	madt_walk_table(madt_parse_ints, NULL);
+ 
+ 	/* Third, we register all the I/O APIC's. */
+ 	for (i = 0; i < NIOAPICS; i++)
+ 		if (ioapics[i].io_apic != NULL)
+ 			ioapic_register(ioapics[i].io_apic);
+ 
+ 	/* Finally, we throw the switch to enable the I/O APIC's. */
+ 	acpi_SetDefaultIntrModel(ACPI_INTR_APIC);
+ 
+ 	return (0);
+ }
+ 
+ static void
+ madt_register(void *dummy __unused)
+ {
+ 
+ 	apic_register_enumerator(&madt_enumerator);
+ }
+ SYSINIT(madt_register, SI_SUB_TUNABLES - 1, SI_ORDER_FIRST,
+     madt_register, NULL)
+ 
+ /*
+  * Call the handler routine for each entry in the MADT table.
+  */
+ static void
+ madt_walk_table(madt_entry_handler *handler, void *arg)
+ {
+ 	APIC_HEADER *entry;
+ 	u_char *p, *end;
+ 
+ 	end = (u_char *)(madt) + madt->Header.Length;
+ 	for (p = (u_char *)(madt + 1); p < end; ) {
+ 		entry = (APIC_HEADER *)p;
+ 		handler(entry, arg);
+ 		p += entry->Length;
+ 	}
+ }
+ 
+ static void
+ madt_probe_cpus_handler(APIC_HEADER *entry, void *arg)
+ {
+ 	PROCESSOR_APIC *proc;
+ 	struct lapic_info *la;
+ 
+ 	switch (entry->Type) {
+ 	case APIC_PROC:
+ 		/*
+ 		 * The MADT does not include a BSP flag, so we have to
+ 		 * let the MP code figure out which CPU is the BSP on
+ 		 * its own.
+ 		 */
+ 		proc = (PROCESSOR_APIC *)entry;
+ #if 0
+ 		if (bootverbose)
+ #endif
+ 			printf("MADT: Found CPU APIC ID %d ACPI ID %d: %s\n",
+ 			    proc->LocalApicId, proc->ProcessorApicId,
+ 			    proc->ProcessorEnabled ? "enabled" : "disabled");
+ 		if (proc->ProcessorApicId > NLAPICS)
+ 			panic("%s: CPU ID %d too high", __func__,
+ 			    proc->ProcessorApicId);
+ 		la = &lapics[proc->ProcessorApicId];
+ 		KASSERT(la->la_present == 0,
+ 		    ("Duplicate local ACPI ID %d", proc->ProcessorApicId));
+ 		la->la_present = 1;
+ 		la->la_apic_id = proc->LocalApicId;
+ 		if (proc->ProcessorEnabled) {
+ 			la->la_enabled = 1;
+ 			lapic_create(proc->LocalApicId, 0);
+ 		}
+ 		break;
+ 	}
+ }
+ 
+ 
+ /*
+  * Add an I/O APIC from an entry in the table.
+  */
+ static void
+ madt_parse_apics(APIC_HEADER *entry, void *arg __unused)
+ {
+ 	IO_APIC *apic;
+ 
+ 
+ 	switch (entry->Type) {
+ 	case APIC_IO:
+ 		apic = (IO_APIC *)entry;
+ #if 0
+ 		if (bootverbose)
+ #endif
+ 			printf("MADT: Found IO APIC ID %d, Vector %d at %p\n",
+ 			    apic->IoApicId, apic->Vector,
+ 			    (void *)apic->IoApicAddress);
+ 		if (apic->IoApicId >= NIOAPICS)
+ 			panic("%s: I/O APIC ID %d too high", __func__,
+ 			    apic->IoApicId);
+ 		if (ioapics[apic->IoApicId].io_apic != NULL)
+ 			panic("%s: Double APIC ID %d", __func__,
+ 			    apic->IoApicId);
+ 		ioapics[apic->IoApicId].io_apic = ioapic_create(
+ 			(uintptr_t)apic->IoApicAddress, apic->IoApicId,
+ 			    apic->Vector);
+ 		ioapics[apic->IoApicId].io_vector = apic->Vector;
+ 		break;
+ 	default:
+ 		break;
+ 	}
+ }
+ 
+ /*
+  * Determine properties of an interrupt source.  Note that for ACPI,
+  * these are only used for ISA interrupts, so we assume ISA bus values
+  * (Active Hi, Edge Triggered) for conforming values.
+  */
+ static u_char
+ interrupt_polarity(UINT16 Polarity)
+ {
+ 
+ 	switch (Polarity) {
+ 	case APIC_POLARITY_CONFORM:
+ 	case APIC_POLARITY_ACTIVEHI:
+ 		return (1);
+ 	case APIC_POLARITY_ACTIVELO:
+ 		return (0);
+ 	default:
+ 		panic("Bogus Interrupt Polarity");
+ 	}
+ }
+ 
+ static u_char
+ interrupt_trigger(UINT16 TriggerMode)
+ {
+ 
+ 	switch (TriggerMode) {
+ 	case APIC_TRIGGER_CONFORM:
+ 	case APIC_TRIGGER_EDGE:
+ 		return (1);
+ 	case APIC_TRIGGER_LEVEL:
+ 		return (0);
+ 	default:
+ 		panic("Bogus Interrupt Trigger Mode");
+ 	}
+ }
+ 
+ /*
+  * Find the local APIC ID associated with a given ACPI Processor ID.
+  */
+ static int
+ madt_find_cpu(u_int acpi_id, u_int *apic_id)
+ {
+ 
+ 	if (!lapics[acpi_id].la_present)
+ 		return (ENOENT);
+ 	*apic_id = lapics[acpi_id].la_apic_id;
+ 	if (lapics[acpi_id].la_enabled)
+ 		return (0);
+ 	else
+ 		return (ENXIO);
+ }
+ 
+ /*
+  * Find the IO APIC and pin on that APIC associated with a given global
+  * interrupt.
+  */
+ static int
+ madt_find_interrupt(int intr, void **apic, u_int *pin)
+ {
+ 	int i, best;
+ 
+ 	best = -1;
+ 	for (i = 0; i < NIOAPICS; i++) {
+ 		if (ioapics[i].io_apic == NULL ||
+ 		    ioapics[i].io_vector > intr)
+ 			continue;
+ 		if (best == -1 ||
+ 		    ioapics[best].io_vector < ioapics[i].io_vector)
+ 			best = i;
+ 	}
+ 	if (best == -1)
+ 		return (ENOENT);
+ 	*apic = ioapics[best].io_apic;
+ 	*pin = intr - ioapics[best].io_vector;
+ 	if (*pin > 32)
+ 		printf("WARNING: Found intpin of %u for vector %d\n", *pin,
+ 		    intr);
+ 	return (0);
+ }
+ 
+ /*
+  * Parse an interrupt source override for an ISA interrupt.
+  */
+ static void
+ madt_parse_interrupt_override(INTERRUPT_SOURCE_OVERRIDE *intr)
+ {
+ 	void *ioapic;
+ 	u_int pin;
+ 
+ 	/* XXXTEST */
+ 	printf("MADT: intr override: source %u, irq %u\n", intr->Source,
+ 	    intr->GlobalSystemInterrupt);
+ 	KASSERT(intr->Bus == 0, ("bus for interrupt overrides must be zero"));
+ 	if (madt_find_interrupt(intr->GlobalSystemInterrupt,
+ 	    &ioapic, &pin) != 0) {
+ 		printf("MADT: Could not find APIC for vector %d (IRQ %d)\n",
+ 		    intr->GlobalSystemInterrupt, intr->Source);
+ 		return;
+ 	}
+ 
+ 	if (intr->Source != intr->GlobalSystemInterrupt)
+ 		ioapic_remap_vector(ioapic, pin, intr->Source);
+ 	ioapic_set_triggermode(ioapic, pin,
+ 	    interrupt_trigger(intr->TriggerMode));
+ 	ioapic_set_polarity(ioapic, pin, interrupt_polarity(intr->Polarity));
+ }
+ 
+ /*
+  * Parse an entry for an NMI routed to an IO APIC.
+  */
+ static void
+ madt_parse_nmi(NMI *nmi)
+ {
+ 	void *ioapic;
+ 	u_int pin;
+ 
+ 	if (madt_find_interrupt(nmi->GlobalSystemInterrupt,
+ 	    &ioapic, &pin) != 0) {
+ 		printf("MADT: Could not find APIC for vector %d\n",
+ 		    nmi->GlobalSystemInterrupt);
+ 		return;
+ 	}
+ 
+ 	ioapic_set_nmi(ioapic, pin);
+ 	if (nmi->TriggerMode != APIC_TRIGGER_CONFORM)
+ 		ioapic_set_triggermode(ioapic, pin,
+ 		    interrupt_trigger(nmi->TriggerMode));
+ 	if (nmi->Polarity != APIC_TRIGGER_CONFORM)
+ 		ioapic_set_polarity(ioapic, pin,
+ 		    interrupt_polarity(nmi->Polarity));
+ }
+ 
+ /*
+  * Parse an entry for an NMI routed to a local APIC LVT pin.
+  */
+ static void
+ madt_parse_local_nmi(LAPIC_NMI *nmi)
+ {
+ 	u_int apic_id, pin;
+ 
+ 	if (nmi->ProcessorApicId == 0xff)
+ 		apic_id = APIC_ID_ALL;
+ 	else if (madt_find_cpu(nmi->ProcessorApicId, &apic_id) != 0) {
+ #if 0
+ 		if (bootverbose)
+ #endif
+ 			printf("MADT: Ignoring local NMI routed to ACPI CPU %u\n",
+ 			    nmi->ProcessorApicId);
+ 		return;
+ 	}
+ 	if (nmi->LINTPin == 0)
+ 		pin = LVT_LINT0;
+ 	else
+ 		pin = LVT_LINT1;
+ 	lapic_set_lvt_mode(apic_id, pin, APIC_LVT_DM_NMI);
+ 	if (nmi->TriggerMode != APIC_TRIGGER_CONFORM)
+ 		lapic_set_lvt_triggermode(apic_id, pin,
+ 		    interrupt_trigger(nmi->TriggerMode));
+ 	if (nmi->Polarity != APIC_POLARITY_CONFORM)
+ 		lapic_set_lvt_polarity(apic_id, pin,
+ 		    interrupt_polarity(nmi->Polarity));
+ }
+ 
+ /*
+  * Parse interrupt entries.
+  */
+ static void
+ madt_parse_ints(APIC_HEADER *entry, void *arg __unused)
+ {
+ 
+ 	switch (entry->Type) {
+ 	case APIC_INTERRUPT_SOURCE_OVERRIDE:
+ 		madt_parse_interrupt_override(
+ 			(INTERRUPT_SOURCE_OVERRIDE *)entry);
+ 		break;
+ 	case APIC_NMI:
+ 		madt_parse_nmi((NMI *)entry);
+ 		break;
+ 	case APIC_LOCAL_APIC_NMI:
+ 		madt_parse_local_nmi((LAPIC_NMI *)entry);
+ 		break;
+ 	}
+ }
Index: i386/conf/GENERIC
===========================================================================
--- sys/i386/conf/GENERIC	2003/10/30 14:48:07	#79
+++ i386/conf/GENERIC	2003/10/30 14:48:07
@@ -66,8 +66,8 @@
 options 	WITNESS_SKIPSPIN	#Don't run witness on spinlocks for speed
 
 # To make an SMP kernel, the next two are needed
-#options 	SMP			# Symmetric MultiProcessor Kernel
-#options 	APIC_IO			# Symmetric (APIC) I/O
+options 	SMP			# Symmetric MultiProcessor Kernel
+device		apic			# I/O APIC
 
 device		isa
 device		eisa
Index: i386/conf/NOTES
===========================================================================
--- sys/i386/conf/NOTES	2003/10/30 14:48:07	#157
+++ i386/conf/NOTES	2003/10/30 14:48:07
@@ -22,7 +22,7 @@
 #####################################################################
 # SMP OPTIONS:
 #
-# APIC_IO enables the use of the IO APIC for Symmetric I/O.
+# The apic device enables the use of the IO APIC for Symmetric I/O.
 #
 # Notes:
 #
@@ -35,7 +35,7 @@
 #
 
 # Mandatory:
-options 	APIC_IO			# Symmetric (APIC) I/O
+device		apic			# I/O apic
 
 #
 # Rogue SMP hardware:
Index: i386/conf/PAE
===========================================================================
--- sys/i386/conf/PAE	2003/10/30 14:48:07	#7
+++ i386/conf/PAE	2003/10/30 14:48:07
@@ -10,10 +10,6 @@
 # To make a PAE kernel, the next option is needed
 options		PAE			# Physical Address Extensions Kernel
 
-# To make an SMP kernel, the next two are needed
-#options 	SMP			# Symmetric MultiProcessor Kernel
-#options 	APIC_IO			# Symmetric (APIC) I/O
-
 # Compile acpi in statically since the module isn't built properly.  Most
 # machines which support large amounts of memory require acpi.
 device		acpi
==== //depot/vendor/freebsd/src/sys/i386/conf/SMP#4 - <none> ===
Index: i386/i386/autoconf.c
===========================================================================
--- sys/i386/i386/autoconf.c	2003/10/30 14:48:07	#18
+++ i386/i386/autoconf.c	2003/10/30 14:48:07
@@ -77,11 +77,6 @@
 
 #include <machine/bootinfo.h>
 #include <machine/md_var.h>
-#ifdef APIC_IO
-#include <machine/smp.h>
-#else
-#include <i386/isa/icu.h>
-#endif /* APIC_IO */
 
 #ifdef DEV_ISA
 #include <isa/isavar.h>
@@ -114,28 +109,11 @@
 {
 
 	/*
-	 * Activate the ICU's.  Note that we are explicitly at splhigh()
-	 * at present as we have no way to disable stray PCI level triggered
-	 * interrupts until the devices have had a driver attached.  This
-	 * is particularly a problem when the interrupts are shared.  For
-	 * example, if IRQ 10 is shared between a disk and network device
-	 * and the disk device generates an interrupt, if we "activate"
-	 * IRQ 10 when the network driver is set up, then we will get
-	 * recursive interrupt 10's as nothing will know how to turn off
-	 * the disk device's interrupt.
-	 *
-	 * Having the ICU's active means we can probe interrupt routing to
-	 * see if a device causes the corresponding pending bit to be set.
-	 *
-	 * This is all rather inconvenient.
+	 * Enable interrupts on the processor.  The interrupts are still
+	 * disabled in the interrupt controllers until interrupt handlers
+	 * are registered.
 	 */
-#ifdef APIC_IO
-	bsp_apic_configure();
-	enable_intr();
-#else
 	enable_intr();
-	INTREN(IRQ_SLAVE);
-#endif /* APIC_IO */
 
 	/* nexus0 is the top of the i386 device tree */
 	device_add_child(root_bus, "nexus", 0);
@@ -151,12 +129,6 @@
 	if (isa_bus_device)
 		isa_probe_children(isa_bus_device);
 #endif
-
-	/*
-	 * Now we're ready to handle (pending) interrupts.
-	 * XXX this is slightly misplaced.
-	 */
-	spl0();
 }
 
 static void
@@ -167,11 +139,6 @@
 	cninit_finish(); 
 
 	if (bootverbose) {
-
-#ifdef APIC_IO
-		imen_dump();
-#endif /* APIC_IO */
-
 #ifdef PC98
 		{
 		int i;
Index: i386/i386/bios.c
===========================================================================
--- sys/i386/i386/bios.c	2003/10/30 14:48:07	#21
+++ i386/i386/bios.c	2003/10/30 14:48:07
@@ -583,20 +583,14 @@
 	}
 
 	/*
-	 * If we are in APIC_IO mode, we should ignore the ISA PIC if it
-	 * shows up.  Likewise, in !APIC_IO mode, we should ignore the
-	 * APIC (less important).
-	 * This is significant because the ISA PIC will claim IRQ 2 (which
-	 * it uses for chaining), while in APIC mode this is a valid IRQ
-	 * available for general use.
+	 * Ignore PICs so that we don't have to worry about the PICs
+	 * claiming IRQs to prevent their use.  The PIC drivers
+	 * already ensure that invalid IRQs are not used.
 	 */
-#ifdef APIC_IO
 	if (!strcmp(pnp_eisaformat(pd->devid), "PNP0000"))	/* ISA PIC */
 	    continue;
-#else
 	if (!strcmp(pnp_eisaformat(pd->devid), "PNP0003"))	/* APIC */
 	    continue;
-#endif	
 	
 	/* Add the device and parse its resources */
 	dev = BUS_ADD_CHILD(parent, ISA_ORDER_PNP, NULL, -1);
